<%@ page language="java" %>
<%@ page contentType="text/html; charset=UTF-8" %>

<%@ page import="java.io.BufferedReader" %>
<%@ page import="java.io.FileReader" %>
<%@ page import="java.io.File" %>
<%@ page import="java.util.Vector" %>
<%@ page import="com.ibm.db2.cwq.util.UserConnection" %>
<%@ page import="com.ibm.db2.cwq.util.WQUtil" %>

<jsp:useBean id="webquerytool_cfg" class="com.ibm.db2.cwq.util.Config" scope="session"/>
<jsp:useBean id="webquerytool_user" class="com.ibm.db2.cwq.util.User" scope="session"/>
<jsp:useBean id="webquerytool_ui" class="com.ibm.db2.cwq.util.UI" scope="session"/>

<%
    response.setHeader("Pragma", "No-cache");
    response.setHeader("Cache-Control", "no-cache");
    response.setDateHeader("Expires",0);

	UserConnection uc =	webquerytool_user.getConnection(
		webquerytool_user.getCurrentCon()
	);



    // -----------------------------------------
    // Header
    String pageName = "import/ImportFixed.jsp";

    String headerTitle = "Fixed Text Import Options";

    boolean headerShowMsg = true;
    boolean headerChangeCon = true;
    boolean headerQuickHelp = true;

    // ---------------------------------------
    // Left Menu
    String[] headerLeft = 
    	{ 
    		"Select", "go('next')", 
    		"Previous", "go('prev')"
    	};

    // ---------------------------------------
    // Right Menu
    String headerRightTitle = "";

    String[] headerRight = new String[0];

    // ---------------------------------------
    // Quick Help
	String headerHelpText = 
		"Fixed Width Import Options. "
		+"<p>"
		+"Select fixed width import options. "
		+"Select the column layout by selecting the where the column begins. The first column is considered to be the start of the row."
		+"<p>"
		+"Click <i>Select</i> to select the column layout and proceed. "
		+"Click <i>Previous</i> to return back to the last screen. ";


%>

<!-- All rights reserved. Licensed Materials Property of IBM          -->
<!-- Note to US Government users                                      -->
<!-- Documentation related to restricted rights                       -->
<!-- Use, duplication or disclosure is subject to restrictions        -->
<!-- set forth in GSA ADP Schedule with IBM Corp.                     -->
<!--This page may contain other proprietary notices and copyright     -->
<!--information, the terms of which must be observed and followed.    -->

<HTML>

<head>
	<TITLE>Import Fixed</TITLE>

	<base href="<%= webquerytool_cfg.getWebRoot(request) %>">

	<META name="COPYRIGHT" 
		content="IBM Corporation (c) 1999-2002, All Rights Reserved">
	<META name="GENERATOR" 
		content="IBM Web Query Tool (c) 1999-2002, All Rights Reserved">

	<SCRIPT language="JavaScript" src="webquery.js">
	</SCRIPT>
</HEAD>

<body bgcolor="FFFFFF" text="#000000" 
	link="#FFFFFF" alink="#FFFF00" vlink="#FFFFFF"
	onMouseOver="hidePopupMenus();">

<form method=post action="<%=webquerytool_cfg.getAppRoot()%>/Import">

<input type=hidden name=op value=process>
<input type=hidden name=page value=fix>
<input type=hidden name=cmd value="">

<%@ include file="../header.inc" %>

<TABLE width=90% align=center><TR><TD>

	<TABLE border=0 cellpadding=0 cellspacing=0 align=center width=100%>
	<TR>
		<TD valign=top>
			<font face=sans-serif size=-1>
	
			<input type=checkbox name=trim checked> Trim fields.
			
			<br>
	
			<input type=checkbox name=header 
				value="<%=webquerytool_ui.getHeader()%>" checked> 
				Treat first row as column headers.
	
			<br>
			<br>
	
			Set the column width by checking the box at the start of each column 
			beginning with the second column.
			
	
			<br>
			<br>
			</font>
		</TD>
	</TR>
	</TABLE>		 	

<% 	
	// ----------------------------------------------
	// create an InputStreamReader

	String fname = com.ibm.db2.cwq.util.WQUtil.getResultsPath(
		webquerytool_cfg.getInstallRoot(), 
		uc, 
		"import.tmp"
	);
	fname = fname.substring(0, fname.length()-5);
	
	
	FileReader freader = new FileReader( new File(fname) );
	BufferedReader bf = new BufferedReader( freader );
	Vector pos = new Vector();
	String header = bf.readLine();
	for ( int m=0; m<header.length()-1; m++ ) 
	{
		if( header.charAt(m) == (int) ' ' || header.charAt(m) == (int) '\t' )	
		{
			if( header.charAt(m+1) != (int) ' ' )
				pos.addElement(new Integer(m+1));	
		}	
	}
	freader.close();
	
	
	// ----------------------------------------------
	// calculate the number of rows 
	freader = new FileReader( new File(fname) );
	int r = 0;
	int rows = 0;

	while( (r = freader.read()) != -1 )
	{
		if( r == (int) '\n')
			rows++;	
	}
	freader.close(); 


	// ----------------------------------------------
	// calculate the biggest length of the first five rows
	freader = new FileReader( new File(fname) );
	bf = new BufferedReader( freader );
	int rowlen = 0;
	int newRowlen = 0;
	String curLine = new String();
	for (int line=0; line<rows && line<6; line++)
	{
		curLine = bf.readLine();
		for (int p=0; p<curLine.length(); p++)
			newRowlen++;
		if (newRowlen > rowlen)
			rowlen = newRowlen;
		newRowlen = 0;	
	}
	freader.close(); 
%>

	<TABLE border=1 cellspacing=0 cellpadding=0 bgcolor="#C0C0C0">
	<TR align=center bgcolor="#6699CC">
		<TD>
			<b><tt>Row</tt></b>
		</TD>
			
<%	
	// ----------------------------------------------
	// display checkboxes

	String colPosChecked = new String();
	for (int b=1; b<=rowlen; b++)
	{
		colPosChecked = "";
		if( pos.contains(new Integer(b-1)) )
				colPosChecked = "checked";
		if( b == 1 ) 
		{
%>
		<TD>
			&nbsp; &nbsp;
		</TD>
<%		} else { %>
		<TD>
			<INPUT type="checkbox" name="FixWidth<%= b %>" <%= colPosChecked %> >
		</TD>
<%		} %>
<%	} %>
	</TR>


<%
	// ----------------------------------------------
	// display first five rows

	freader = new FileReader( new File(fname) );
	bf = new BufferedReader( freader );
	String curRow = new String();
	for (int row=0; row<rows && row<6; row++)
	{ 
%>
	<TR align=center>
		<TD bgcolor="#6699CC">
			<b><tt><%= row+1 %></tt></b>
		</TD>
<%		
		curRow = bf.readLine();
		for (int s=0; s<curRow.length(); s++)
		{
			if( curRow.charAt(s) == (int) ' ' || curRow.charAt(s) == (int) '\t' )
			{ %>
		<TD>
			<tt>&nbsp;</tt>
		</TD>
<% 			}
			else
			{ %>
		<TD>
			<font size=-2 color="#000000">
			<%= curRow.charAt(s) %>
			</font>
		</TD>
<% 			}
		} %>
	</tr>
<%	} %>

	</TABLE>

<%	freader.close(); %>


</TD></TR></TABLE>

<input type=hidden name=rowlen value="<%= rowlen %>">

</form>

<script language="JavaScript">
<!--
	if (<%= webquerytool_ui.getReloadMenu() %>)
		window.top.HeaderFrame.menuRe( 'Menu', 'refresh', '');
//-->
</script>

</body>

</html>
