<%@ page language="java" %>
<%@ page contentType="text/html; charset=UTF-8" %>

<%@ page import="java.util.*" %>
<%@ page import="com.ibm.db2.cwq.util.UserConnection" %>

<jsp:useBean id="webquerytool_cfg" class="com.ibm.db2.cwq.util.Config" scope="session"/>
<jsp:useBean id="webquerytool_user" class="com.ibm.db2.cwq.util.User" scope="session"/>
<jsp:useBean id="webquerytool_ui" class="com.ibm.db2.cwq.util.UI" scope="session"/>

<%
    response.setHeader("Pragma", "No-cache");
    response.setHeader("Cache-Control", "no-cache");
    response.setDateHeader("Expires",0);

	UserConnection uc = webquerytool_user.getConnection(
		webquerytool_user.getCurrentCon()
	);


    // -----------------------------------------
    // Header
    String pageName = "import/ImportOptions.jsp";

    String headerTitle = "Import Options";

    boolean headerShowMsg = true;
    boolean headerChangeCon = true;
    boolean headerQuickHelp = true;

    // ---------------------------------------
    // Left Menu
    String[] headerLeft = 
    	{ 
    		"Import", "go('next')", 
    		"Previous", "go('prev')"
    	};

    // ---------------------------------------
    // Right Menu
    String headerRightTitle = "";

    String[] headerRight = new String[0];

    // ---------------------------------------
    // Quick Help
	String headerHelpText = 
		"Import Options"
		+"<p>"
		+"<b>Options</b>"
		+"<br>"
		+"Set rows to import, file name for result set. "
		+"Locale can be set to determine format of date, time, and numbers. "
		+"NULL value when matched set the column to NULL. "
		+"<p>"
		+"<b>Fields</b>"
		+"<br>"
		+"Fields may be included or skipped by checking the <i>Include</i> checkbox. "
		+"Verify that the columns are named correctly. "
		+"Associate a datatype to the column as appropriate. "
		+"Format can be used to help convert date, time and number values. "
		+"Match values can be specified in order to limit the imported data. "
		+"<p>"
		+"Click <i>Import</i> to perform the import. "
		+"Click <i>Previous</i> to change format specific operations. ";


%>

<!-- All rights reserved. Licensed Materials Property of IBM          -->
<!-- Note to US Government users                                      -->
<!-- Documentation related to restricted rights                       -->
<!-- Use, duplication or disclosure is subject to restrictions        -->
<!-- set forth in GSA ADP Schedule with IBM Corp.                     -->
<!--This page may contain other proprietary notices and copyright     -->
<!--information, the terms of which must be observed and followed.    -->

<HTML>

<head>
	<TITLE>Import Options</TITLE>

	<base href="<%= webquerytool_cfg.getWebRoot(request) %>">

	<META name="COPYRIGHT" 
		content="IBM Corporation (c) 1999-2002, All Rights Reserved">
	<META name="GENERATOR" 
		content="IBM Web Query Tool (c) 1999-2002, All Rights Reserved">

	<SCRIPT language="JavaScript" src="webquery.js">
	</SCRIPT>

<SCRIPT language="JavaScript">
<!--

function checkRangeButton()
{
	document.forms[0].RowRange[1].checked = true;
}

function viewSampleData()
{
	var sd = window.open( "sampleData.jsp", "sampleData",
		"resizable,scrollbars,"+
			"width=550,height=300,"+
			"screenY="+(window.screenY+50)+","+
			"screenX="+(window.screenX+50)
	);

	sd.focus();
}

//-->
</SCRIPT>
</HEAD>

<body bgcolor="FFFFFF" text="#000000" 
	link="#FFFFFF" alink="#FFFF00" vlink="#FFFFFF"
	onMouseOver="hidePopupMenus();">

<form method=post action="<%=webquerytool_cfg.getAppRoot()%>/Import">

<input type=hidden name=op value=process>
<input type=hidden name=page value=options>
<input type=hidden name=cmd value="">

<%@ include file="../header.inc" %>

<TABLE width=90% align=center><TR><TD>

<%
	// GENERAL OPTIONS
%>

<table border=0 cellpadding=2 cellspacing=1 align=center width=100%>
<tr valign=top align=left>
	<td bgcolor="#6699CC">
		<font face=sans-serif size=-1 color="#FFFFFF">
		<nobr>
		<b>Import Rows:</b>
		</nobr>
		</font>
	</td>

	<td bgcolor="#6699CC">
		<font face=sans-serif size=-1 color="#FFFFFF">
		<b>Result File:</b>
		</font>
	</td>
</tr>

<tr valign=top align=left>
	<td bgcolor="#C0C0C0">
		<font face="arial,sans-serif"> 
		<nobr>
		<input style="background : #C0C0C0; color : black"
			type="radio" name="RowRange" value="all" checked>
			All rows
		</nobr>

		<br>

		<nobr>
		<input style="background : #C0C0C0; color : black"
			type="radio" name="RowRange" value="range">
			<input size="3" type="text" name="StartRow"
				onFocus="checkRangeButton()"
				value="1">

			-

			<input size="3" type="text" name="EndRow"
				onFocus="checkRangeButton()"
				value="<%= webquerytool_ui.getData().getRowCount() %>">

		</nobr>
		</font>
	</td>

	<td bgcolor="#C0C0C0">
		<font face=sans-serif>
		<INPUT type=text name=resultfile
			value="<%= webquerytool_ui.getResultsFile() %>">
		</font>
	</td>
</tr>	


<tr valign=top align=left>
	<td bgcolor="#6699CC">
		<font face=sans-serif size=-1 color="#FFFFFF">
		<b>Locale:</b>
		</font>
	</td>

	<td bgcolor="#6699CC">
		<font face=sans-serif size=-1 color="#FFFFFF">
		<b>Null Value:</b>
		</font>
	</td>
</tr>

<tr valign=top align=left>
	<td bgcolor="#C0C0C0">
		<font face=sans-serif>
		<SELECT name=locale>
<% 	String locSel = "";
	String locReq = request.getHeader("Accept-Language").toLowerCase();
	if( locReq.indexOf("-") != -1 )
		locReq = locReq.substring(0,locReq.indexOf("-")) + "_" + 
			locReq.substring(locReq.indexOf("-")+1,locReq.length());
	boolean locSelected = false;
	java.util.Locale list[] = java.text.DateFormat.getAvailableLocales();
	for (int i=0; i<list.length; i++) 
	{ 
		if( list[i].toString().toLowerCase().startsWith(locReq)
			&& !locSelected )
		{
			locSel = " SELECTED";
			locSelected = true;
		}
		else
			locSel = "";
%>
			<OPTION value="<%= list[i].toString() %>" <%= locSel %>>
				<%= list[i].getDisplayName() %>
			</OPTION>
<%	}	 %>
		</SELECT>
		</font>
	</td>

	<td bgcolor="#C0C0C0">
		<font face=sans-serif>
		<INPUT type=text name=displaynull 
			value="<%= webquerytool_ui.getDisplayNulls() %>">
		</font>
	</td>
</tr>

</table>


<% 	
	// ================================
	// problem row table
	// ================================
%>
<%	if( webquerytool_ui.getData().getProblemRow().size() > 0 )
	{
		Properties prob = new Properties();
		int row;
		Vector rowV = new Vector();
		Vector probC = new Vector();
		String tableCol = new String();
		int probColCount = 0;
%>

<BR>
<BR>

<TABLE cellspacing=2 cellpadding=2 border=0 width=100%>
<tr bgcolor="#336699" align=center>
	<td colspan=<%= webquerytool_ui.getData().getColumnCount()+2 %>>
		<font face=sans-serif color="#FF0000" size=+1>
		Problem Data Rows
		</font>
	</td>
</tr>
<tr bgcolor="#6699CC" align=center>
	<td>
		<font face=sans-serif color="#FFFFFF" size=-1>
		Row
		</font>
	</td>
	<td>
		<font face=sans-serif color="#FFFFFF" size=-1>
		Ignore
		</font>
	</td>
<%	for( int colCount=0; colCount<webquerytool_ui.getData().getColumnCount(); colCount++) { %> 
	<td>
		<font face=sans-serif color="#FFFFFF" size=-1>
		<%= ((Properties)webquerytool_ui.getData().getColumnDef(colCount)).get("name") %>
		</font>
	</td>
<%	} %>
</tr>
<% 		for( int pi=0; pi<webquerytool_ui.getData().getProblemRow().size(); pi++ )
		{
			prob = (Properties) 
				webquerytool_ui.getData().getProblemRow().elementAt(pi);
			
			row = ((Integer)prob.get("row")).intValue();
			probC = (Vector) prob.get("cols");

			rowV = webquerytool_ui.getData().getRow(row);
			probColCount = 0;
%>			
<TR bgcolor="#C0C0C0">
	<TD align=center>
		<font face="arial,sans-serif" size=-1>
		<%= row+1 %>
		</font>
	</TD>
	<TD align=center>
		<font face="arial,sans-serif" size=-1>
		<INPUT type=checkbox value=<%= pi %>>
		</font>
	</TD>
<% 			for( int col=0; col<rowV.size(); col++ )
			{
				tableCol = (String) ((Properties)rowV.elementAt(col)).get("value");
				if( probColCount < probC.size() 
					&& ((Integer)probC.elementAt(probColCount)).intValue() == col )
				{
					probColCount++;
					tableCol = 
						"<INPUT type=text name=col"+col+" value=\""+tableCol+"\" size=7>";
				}
				else
				{
					if( tableCol.equals("") )
						tableCol = "&nbsp;";
				}
%>
	<TD>
		<font face="arial,sans-serif" size=-1>
		<%= tableCol %>
		</font>
	</TD>
<% 			} %>
</TR>
<% 		} %>
</TABLE>
<% } %>


<%
	// COLUMN OPTIONS
%>

<br>
<br>
<table border=0 cellpadding=2 cellspacing=1 align=center width=100%>
<tr bgcolor="#6699CC" align=center>
	<td>
		<font face=sans-serif color="#FFFFFF" size=-1>
		<B>Include</B>
		</font>
	</td>
	<td>
		<font face=sans-serif color="#FFFFFF" size=-1>
		<B>Column</B>
		</font>
	</td>
	<td>
		<font face=sans-serif color="#FFFFFF" size=-1>
		<B>Data type</B>
		</font>
	</td>
	<td>
		<font face=sans-serif color="#FFFFFF" size=-1>
		<B>Format</B>
		</font>
	</td>
	<td>
		<font face=sans-serif color="#FFFFFF" size=-1>
		<B>Match</B>
		</font>
	</td>
</tr>
          
<%	Properties p = new Properties();
	for( int i=0; i<webquerytool_ui.getData().getColumnCount();i++ ) 
	{
		p = (Properties) webquerytool_ui.getData().getColumnDef(i);
%>
<tr align=center bgcolor="#C0C0C0">
	<td>
		<input type="checkbox" name="Include<%= p.get("order") %>" 
			<%= p.get("include")==null?"":"checked" %>>
	</td>  

	<td>
		<input size="15" name="Colname<%= p.get("order") %>" 
			type="text" value="<%= p.get("name") %>">
	</td>  
	
	<td>
		<SELECT size=1 name="dataType<%= p.get("order")%>">
<%
		Enumeration e = uc.getDataType().enumerate();
		String val = new String();
		String sel = new String();
		Properties dt = null;
		while( e.hasMoreElements() )
		{
			val = (String) e.nextElement();
			dt = (Properties) uc.getDataType().get(val);
			if( val.toLowerCase().equals(((String)p.get("type")).toLowerCase()) )
				sel = "SELECTED";
			else
				sel = "";
%>
			<OPTION value="<%= val %>" <%= sel %>><%= val %></OPTION>
<% 		} %>
		</SELECT>
	</td>     	     

	<td>
		<input size="10" name="Format<%= p.get("order") %>" 
			type="text" value="<%= p.get("format") != null ? p.get("format") : "" %>">
	</td>

	<td>
		<input size="10" name="Match<%= p.get("order") %>" 
			type="text" value="<%= p.get("match") != null ? p.get("match") : "" %>">
	</td>
</tr>
<% } %>			
</table>
</form>

</TD></TR></TABLE>

<script language="JavaScript">
<!--
if (<%= webquerytool_ui.getReloadMenu() %>)
	window.top.HeaderFrame.menuRe( 'Menu', 'refresh', '');
//-->
</script>
</body>
</html>
