<%@ page language="java" %>

<%@ page import="java.util.Enumeration" %>
<%@ page import="java.util.Properties" %>
<%@ page import="java.util.Hashtable" %>
<%@ page import="java.util.Vector" %>
<%@ page import="java.util.Date" %>

<%@ page import="java.io.BufferedReader" %>
<%@ page import="java.io.StringReader" %>
<%@ page import="java.text.SimpleDateFormat" %>

<jsp:useBean id="webquerytool_cfg" class="com.ibm.db2.cwq.util.Config" scope="session"/>
<jsp:useBean id="webquerytool_user" class="com.ibm.db2.cwq.util.User" scope="session"/>
<jsp:useBean id="webquerytool_ui" class="com.ibm.db2.cwq.util.UI" scope="session"/>

<jsp:useBean id="cwqQuery" class="com.rocketsoftware.datautil.Query" scope="session"/>

<% 
    response.setContentType( "text/vnd.wap.wml" );

	SimpleDateFormat sd = new SimpleDateFormat("dd, MMM yyyy hh:mm:ss 'GMT'");

    response.setHeader("Expires","Mon, 26 Jul 1997 05:00:00 GMT");
    response.setHeader("Last-Modified", sd.format(new Date()));
    response.setHeader("Cache-Control", "no-cache, must-revalidate");
    response.setHeader("Pragma", "no-cache");


	Hashtable varToUse = new Hashtable();
	String line = null;
	boolean eof = false;


	String commit = "end";
	if( cwqQuery.getAutoCommit() == cwqQuery.COMMIT_OFF )
		commit = "off";
	else if( cwqQuery.getAutoCommit() == cwqQuery.COMMIT_EVERY )
		commit = "every";
		
	BufferedReader br = new BufferedReader(
		new StringReader(
			cwqQuery.getQuery()
		)
	);

	while( !eof )
	{
		if( (line = br.readLine()) == null )
			eof = true;
		else
		{
			if( line.indexOf("//") != -1 )
				line = line.substring(0, line.indexOf("//") );

			if( line.indexOf("--") != -1 )
				line = line.substring(0, line.indexOf("--") );

			for( int i=0; i<webquerytool_ui.getSQLParam().size(); i++ )
			{
				Properties v = (Properties) webquerytool_ui.getSQLParam().elementAt(i);
				if( line.indexOf( (String) v.get("name") ) != -1 )
					varToUse.put( new Integer(i), "1" );
			}
		}
	}

	br.close();
%>

<?xml version="1.0"?>
<!DOCTYPE wml PUBLIC "-//WAPFORUM//DTD WML 1.1//EN" 
	"http://www.wapforum.org/DTD/wml_1.1.xml">

<wml>

<head>
	<meta name="COPYRIGHT" 
		content="IBM Corporation (c) 1999-2001, All Rights Reserved"/>
	<meta name="GENERATOR" 
		content="IBM Web Query (c) 1999-2001, All Rights Reserved"/>
	<meta forua="true" 
		http-equiv="Cache-Control" content="max-age=-1"/>
</head>

<card id="main">
	<onevent type="onenterforward">
		<refresh>
			<setvar name="commit" value="<%= commit %>"/>
			<setvar name="resultname" 
				value="<%= cwqQuery.getResultName() %>"/>
			<setvar name="maxrows" 
				value="<%= cwqQuery.getQueryRowLimit() %>"/>
			<setvar name="timeout" 
				value="<%= cwqQuery.getQueryTimeOut() %>"/>
		</refresh>
	</onevent>

	<p align="center" mode="nowrap">
	    <b>DB2 Web Query</b> <br/>

	    <i>Prepare Query</i>
	</p>

	<p align="left" mode="nowrap">
		<select name="cmd">
<% 	Properties vParam = new Properties();
	for( int i=0; i<webquerytool_ui.getSQLParam().size(); i++ )
	{
		vParam = (Properties) webquerytool_ui.getSQLParam().elementAt(i);

		if( varToUse.get( new Integer(i) ) != null ) 
		{
%>
			<option title="Set">
				<onevent type="onpick">
					<go href="#var<%= i %>Card"/>
				</onevent>
				VAR:<%= vParam.get("name") %>
			</option>
<%		} %>
<%	} %>

			<option title="Run">
				<onevent type="onpick">
					<go method="post" 
						href="<%= webquerytool_cfg.getAppRoot() %>/SQLText">
						<postfield name="op" value="process"/>
						<postfield name="page" value="sqlvars"/>
						<postfield name="cmd" value="sqlvarsnext"/>

						<postfield name="commit" value="$(commit)"/>
						<postfield name="resultname" value="$(resultname)"/>
						<postfield name="MaxRows" value="$(maxrows)"/>
						<postfield name="TimeOut" value="$(timeout)"/>
					</go>
				</onevent>
				Run
			</option>

			<option title="Change">
				<onevent type="onpick">
					<go href="#commitCard"/>
				</onevent>
				Commit:$(commit)
			</option>

			<option title="Change">
				<onevent type="onpick">
					<go href="#resultnameCard"/>
				</onevent>
				Result:$(resultname)
			</option>

			<option title="Change">
				<onevent type="onpick">
					<go href="#maxrowsCard"/>
				</onevent>
				Max Rows:$(maxrows)
			</option>

			<option title="Change">
				<onevent type="onpick">
					<go href="#timeoutCard"/>
				</onevent>
				Timeout:$(timeout)
			</option>

			<option title="Options">
				<onevent type="onpick">
					<go href="<%=webquerytool_cfg.getWebRoot(request)%>OptionsPage.jsp"/>
				</onevent>
				Options
			</option>

		</select>
	</p>
</card>


    
<card id="commitCard">
	<p align="center" mode="nowrap"> 
		<b>DB2 Web Query</b> <br/>

		<i>Auto-Commit</i>
	</p>

	<p align="left" mode="nowrap"> 
	    <select name="commit">
			<option value="off">
				Off
			</option>

			<option value="end">
				When finished
			</option>

			<option value="every">
				After each statement
			</option>
	    </select>
	</p>
</card>
    


<card id="resultnameCard">
	<p align="center" mode="nowrap">
	    <b>DB2 Web Query</b> <br/>

	    <i>Query</i>
	</p>

	<p align="left" mode="nowrap">
	    Result Name: 

	    <input type="text" name="resultname" value="$(resultname)"/>
	</p>
</card>





<card id="maxrowsCard">
	<p align="center" mode="nowrap">
	    <b>DB2 Web Query</b> <br/>

	    <i>Query</i>
	</p>

	<p align="left" mode="nowrap">
	    Max Rows: 

	    <input type="text" format="4N" 
	    	name="maxrows" value="$(maxrows)"/>
	</p>
</card>



<card id="timeoutCard">
	<p align="center" mode="nowrap">
	    <b>DB2 Web Query</b> <br/>

	    <i>Query Timeout</i>
	</p>

	<p align="left" mode="nowrap">
	    Timeout: 

	    <input type="text" format="4N" 
	    	name="timeout" value="$(timeout)"/>
	</p>
</card>



<%	// ---------------------------------------------------------------
	// Pop-Up Menu Defination
	// ---------------------------------------------------------------

	for( int i=0; i<webquerytool_ui.getSQLParam().size(); i++ )
	{
		vParam = (Properties) webquerytool_ui.getSQLParam().elementAt(i);

		if( varToUse.get( new Integer(i) ) != null ) 
		{
%>
<card id="var<%= i %>Card">
	<onevent type="onenterforward">
		<refresh>
			<setvar name="p" value="<%= i %>"/>
			<setvar name="v" value="<%= vParam.get("value") %>"/>
			<setvar name="match" value="<%= vParam.get("match") %>"/>
		</refresh>
	</onevent>

	<do type="accept" label="Set">
		<go href="#confirmCard"/>
	</do>

	<p align="center" mode="nowrap">
	    <b>DB2 Web Query</b> <br/>

	    <i>Query Variable</i>
	</p>


<% 			if( vParam.get("select") != null )
			{
				String selText = new String();
				Properties selProp = new Properties();
%>
	<p align="left" mode="wrap">
		Set <%= vParam.get("name") %> value(s)
		<br/>

		<select name="v" multiple="<%= vParam.get("multiple")==null?"false":"true" %>">
<%				for( int j=0; j<((Vector)vParam.get("select")).size(); j++ )
				{
					selProp = (Properties) ((Vector)vParam.get("select")).elementAt(j);

					// ((String)vParam.get("value")).equals( ((String)selProp.get("value")) )?"SELECTED":""
					selText = "";
					if( ((Vector)vParam.get("selectvalue")).contains( ((String)selProp.get("value")) ) )
						selText = "SELECTED";
%>
			<option value="<%= selProp.get("value") %>">
				<%= selProp.get("display") %>
			</option>
<%				} %>
		</select>
	</p>

<% 			}
			else
			{
				// user specified.
%>
	<p align="left" mode="nowrap">
		Set <%= vParam.get("name") %> value

		<input type="text" format="*m"
			name="v" value="$(v)"/>
	</p>
<%			} %>
</card>

<%		} %>
<%	} %>


<%	if( webquerytool_ui.getSQLParam().size() > 0 ) { %>

<card id="confirmCard">
	<p align="center" mode="nowrap">
	    <b>DB2 Web Query</b> <br/>

	    <i>Query Variable</i>
	</p>

	<p align="left" mode="nowrap">
		<select>
			<option>
				<onevent type="onpick">
					<go method="post" href="<%= webquerytool_cfg.getAppRoot() %>/SQLText">
						<postfield name="op" value="process"/>
						<postfield name="page" value="sqlvars"/>
						<postfield name="cmd" value="setvar"/>
						<postfield name="interface" value="wap"/>

						<postfield name="p" value="$(p)"/>
						<postfield name="v" value="$(v)"/>
						<postfield name="match" value="$(match)"/>

						<postfield name="use" value="Use"/>
					</go>
				</onevent>
				Use
			</option>

			<option>
				<onevent type="onpick">
					<go method="post" href="<%= webquerytool_cfg.getAppRoot() %>/SQLText">
						<postfield name="op" value="process"/>
						<postfield name="page" value="sqlvars"/>
						<postfield name="cmd" value="setvar"/>
						<postfield name="interface" value="wap"/>

						<postfield name="p" value="$(p)"/>
						<postfield name="v" value="$(v)"/>
						<postfield name="match" value="$(match)"/>

						<postfield name="ignore" value="Ignore"/>
					</go>
				</onevent>
				Ignore
			</option>

			<option>
				<onevent type="onpick">
					<go method="post" href="<%= webquerytool_cfg.getAppRoot() %>/SQLText">
						<postfield name="op" value="process"/>
						<postfield name="page" value="sqlvars"/>
						<postfield name="cmd" value="setvar"/>
						<postfield name="interface" value="wap"/>

						<postfield name="p" value="$(p)"/>
						<postfield name="v" value="$(v)"/>
						<postfield name="match" value="$(match)"/>

						<postfield name="all" value="on"/>
						<postfield name="use" value="Use"/>
					</go>
				</onevent>
				Use All
			</option>

			<option>
				<onevent type="onpick">
					<go method="post" href="<%= webquerytool_cfg.getAppRoot() %>/SQLText">
						<postfield name="op" value="process"/>
						<postfield name="page" value="sqlvars"/>
						<postfield name="cmd" value="setvar"/>
						<postfield name="interface" value="wap"/>

						<postfield name="p" value="$(p)"/>
						<postfield name="v" value="$(v)"/>
						<postfield name="match" value="$(match)"/>

						<postfield name="all" value="on"/>
						<postfield name="ignore" value="Ignore"/>
					</go>
				</onevent>
				Ignore All
			</option>

			<option>
				<onevent type="onpick">
					<go href="#main"/>
				</onevent>
				Cancel
			</option>
		</select>
	</p>
</card>

<%	} %>


</wml>
